/************************************************************************************/
/*  Program name CAPFNDEXT_FORM_FUNCTIONS.sql                                       */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 28 DEC, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDEXT_FORM_FUNCTIONS';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFND_FORM_FUNCTIONS.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT 
        FFF.*
	FROM   
        FND_FORM_FUNCTIONS	FFF,
        FND_MENUS			FM,
        FND_MENU_ENTRIES	FME
	WHERE	FM.MENU_NAME	LIKE	p_NGO||'%'
	AND		FM.MENU_ID	=	FME.MENU_ID
	AND		FME.FUNCTION_ID	=	FFF.FUNCTION_ID;

BEGIN
	lv_NGO_Name		:=	TRIM(UPPER('&1'));

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.FUNCTION_ID||CHR(9)||
				C1.FUNCTION_NAME||CHR(9)||
					C1.APPLICATION_ID||CHR(9)||
				C1.FORM_ID||CHR(9)||
				C1.PARAMETERS||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.TYPE||CHR(9)||
				C1.WEB_HOST_NAME||CHR(9)||
				C1.WEB_AGENT_NAME||CHR(9)||
				C1.WEB_HTML_CALL||CHR(9)||
				C1.WEB_ENCRYPT_PARAMETERS||CHR(9)||
				C1.WEB_SECURED||CHR(9)||
				C1.WEB_ICON||CHR(9)||
				C1.OBJECT_ID||CHR(9)||
				C1.REGION_APPLICATION_ID||CHR(9)||
				C1.REGION_CODE||CHR(9)||
				C1.MAINTENANCE_MODE_SUPPORT||CHR(9)||
				C1.CONTEXT_DEPENDENCE||CHR(9)||
				C1.JRAD_REF_PATH||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetAppName(C1.APPLICATION_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		IF	lv_Scc_Count	=	0	THEN
			lv_Err_Msg	:=	lv_NGO_Name||': No form functions for this NGO';
		END IF;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
